from test.test_support import verify, run_unittest
import unittest
import urllib2
import os
from urllib2 import Request, OpenerDirector

# A couple trivial tests

try:
    urllib2.urlopen('bogus url')
except ValueError:
    pass
else:
    verify(0)

# XXX Name hacking to get this to work on Windows.
fname = os.path.abspath(urllib2.__file__).replace('\\', '/')
if fname[1:2] == ":":
    fname = fname[2:]
# And more hacking to get it to work on MacOS. This assumes
# urllib.pathname2url works, unfortunately...
if os.name == 'mac':
    fname = '/' + fname.replace(':', '/')
elif os.name == 'riscos':
    import string
    fname = os.expand(fname)
    fname = fname.translate(string.maketrans("/.", "./"))

file_url = "file://%s" % fname
f = urllib2.urlopen(file_url)

buf = f.read()
f.close()

class MockOpener:
    addheaders = []
    def open(self, req, data=None):
        self.req, self.data = req, data
    def error(self, proto, *args):
        self.proto, self.args = proto, args
                                
class MockFile:
    def read(self, count=None): pass
    def readline(self, count=None): pass
    def close(self): pass

class MockHeaders(dict):
    def getheaders(self, name):
        return self.values()
            
class HandlerTests(unittest.TestCase):
    def test_invalid_redirect(self):
        from_url = "http://example.com/a.html"
        valid_schemes = ['http', 'https', 'ftp']
        invalid_schemes = ['file', 'imap', 'ldap']
        schemeless_url = "example.com/b.html"
        h = urllib2.HTTPRedirectHandler()
        o = h.parent = MockOpener()
        req = Request(from_url)
        for scheme in invalid_schemes:
            invalid_url = scheme + '://' + schemeless_url
            self.assertRaises(urllib2.HTTPError, h.http_error_302,
                              req, MockFile(), 302, "Security Loophole",
                              MockHeaders({"location": invalid_url}))
            
        for scheme in valid_schemes:
            valid_url = scheme + '://' + schemeless_url
            h.http_error_302(req, MockFile(), 302, "That's fine",
                             MockHeaders({"location": valid_url}))
            self.assertEqual(o.req.get_full_url(), valid_url)
            
            
def test_main(verbose=None):
    tests = (HandlerTests, )
    run_unittest(*tests)

if __name__ == "__main__":
    test_main(verbose=True)
                                    
